Bug 245057 - lang/ghc: drop GCC for powerpc64 elfv2
Summary: lang/ghc: drop GCC for powerpc64 elfv2
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: powerpc Any
: --- Affects Only Me
Assignee: freebsd-haskell mailing list
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2020-03-25 16:23 UTC by Piotr Kubaj
Modified: 2020-03-27 17:46 UTC (History)
4 users (show)

See Also:
bugzilla: maintainer-feedback? (haskell)


Attachments
patch (3.04 KB, patch)
2020-03-25 16:23 UTC, Piotr Kubaj
pkubaj: maintainer-approval? (haskell)
Details | Diff
patch (4.83 KB, patch)
2020-03-26 19:27 UTC, Mikael Urankar
no flags Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Piotr Kubaj freebsd_committer 2020-03-25 16:23:57 UTC
Created attachment 212703 [details]
patch

New bootstrap: https://people.freebsd.org/~pkubaj/ghc-8.6.5-boot-powerpc64-freebsd-elfv2.tar.xz

GCC is not required anymore on powerpc64 elfv2, but to also use lld, additional patch is necessary. Also add USES=compiler:c11 to use GCC from ports on elfv1, GHC can't be compiler with GCC 4.2.
Comment 1 Gleb Popov freebsd_committer 2020-03-25 17:21:42 UTC
Is iserv patch actually a proper fix? Is the comment true for FreeBSD as well as Solaris?
Comment 2 Piotr Kubaj freebsd_committer 2020-03-25 17:59:48 UTC
Um, the suggestion to remove lines with --export-dynamic was done by mikael@. I actually only generated the bootstrap and made the whole patch.

So maybe mikael@ can explain :)
Comment 3 Piotr Kubaj freebsd_committer 2020-03-25 17:59:53 UTC
Um, the suggestion to remove lines with --export-dynamic was done by mikael@. I actually only generated the bootstrap and made the whole patch.

So maybe mikael@ can explain :)
Comment 4 Piotr Kubaj freebsd_committer 2020-03-25 18:01:03 UTC
Without removing this parameter, linking fails with:
ld: error: -r and --export-dynamic may not be used together
Comment 5 Gleb Popov freebsd_committer 2020-03-25 18:33:51 UTC
I reported an issue upstream about linker error: https://gitlab.haskell.org/ghc/ghc/issues/17962

As for patch, I'll commit it shortly.
Comment 6 Mikael Urankar freebsd_committer 2020-03-25 18:37:42 UTC
I also want to update the arm bootstrap and drop gcc on these arches
Comment 7 Mikael Urankar freebsd_committer 2020-03-25 18:38:35 UTC
Piotr, can you also regenerate the bootstrap on 12.1?
Comment 8 Mikael Urankar freebsd_committer 2020-03-25 18:42:55 UTC
gcc is still required for elfv1? (it's been a while, I'm not sure)
Comment 9 Piotr Kubaj freebsd_committer 2020-03-25 19:05:11 UTC
(In reply to Mikael Urankar from comment #7)
There's no need to regenerate the bootstrap. GHC won't build with GCC 4.2.
Comment 10 Mikael Urankar freebsd_committer 2020-03-25 19:12:34 UTC
(In reply to Piotr Kubaj from comment #9)
We can drop this if all the bootstraps are 8.6.5 https://github.com/freebsd/freebsd-ports/blob/master/lang/ghc/Makefile#L105
Comment 11 commit-hook freebsd_committer 2020-03-26 18:34:12 UTC
A commit references this bug:

Author: arrowd
Date: Thu Mar 26 18:33:21 UTC 2020
New revision: 529205
URL: https://svnweb.freebsd.org/changeset/ports/529205

Log:
  Update bootstraps for ARM architectures, get rid of GCC on powerpc64 elfv2/

  PR:		245057
  Submitted by:	pkubaj, mikael

Changes:
  head/lang/ghc/Makefile
  head/lang/ghc/distinfo
  head/lang/ghc/files/patch-utils_iserv_ghc.mk
Comment 12 Mikael Urankar freebsd_committer 2020-03-26 19:27:46 UTC
Created attachment 212734 [details]
patch

binutils and gcc are not needed on arm anymore
bump the required FreeBSD version to 12.1-RELEASE
drop the need of binutils:strip, elftoolchain:strip slowness is fixed in 12.1-RELEASE
Comment 13 commit-hook freebsd_committer 2020-03-27 17:46:58 UTC
A commit references this bug:

Author: arrowd
Date: Fri Mar 27 17:45:39 UTC 2020
New revision: 529272
URL: https://svnweb.freebsd.org/changeset/ports/529272

Log:
  lang/ghc: Don't use GCC on ARM arches. Cleanup Makefile.

  PR:		245057
  Submitted by:	mikael

Changes:
  head/lang/ghc/Makefile